;====================================================================
; Processor		: ATmega8515
; Compiler		: AVRASM
;====================================================================

;====================================================================
; DEFINITIONS
;====================================================================

.include "m8515def.inc"
.def temp = r16 ; temporary register
.def counter = r23 ;
.def iODat = r17;
.def counterLEDPoint = r20;
.def value = r21;
.def score = r9;
.def listenStart = r10;
.def listenReset = r11;
.def number = r25;
.def numberToCompare = r4
.def timer = r8;
.def iODat2 = r24
.def writeTo2 = r12
.equ qATable = 0x60
; .equ best_loc = 0x90

;====================================================================
; AGREEMENT
;====================================================================
; PORT A - LCD
; PORT B - LCD
; PORT C - KEYPAD
; PORT D - BUTTON
; PORT E - LED

;====================================================================
; RESET and INTERRUPT VECTORS
;====================================================================

.org $00
rjmp MAIN
.org $01
rjmp MULAI
.org $02
rjmp RESET
.org $07
rjmp ISR_TOV0

;====================================================================
; CODE SEGMENT
;====================================================================

MAIN:
	;INIT_STACK:
	ldi temp, low(RAMEND)
	out	SPL,r16	            ;init Stack Pointer		
	ldi temp, high(RAMEND)
	out SPH, temp

	
;	subi timer, 0b11010000
	rcall INIT_LED
	rcall INIT_KEYPAD
	rcall INIT_INTERRUPT
	rcall COPY_SOALTABLE_TO_MEMORY
	rcall INIT_LCD_MAIN


WAIT_MULAI:
	tst listenStart
	breq WAIT_MULAI
	ldi temp, 0
	mov listenStart, temp
	rcall INIT_LCD_MAIN1
	; rcall INIT_TIMER
	rcall START_GAME

DELAY_00:
	; Generated by delay loop calculator
	; at http://www.bretmulvey.com/avrdelay.html
	;
	; Delay 4 000 cycles
	; 500us at 8.0 MHz

	    ldi  r18, 6
	    ldi  r19, 49
	L0: dec  r19
	    brne L0
	    dec  r18
	    brne L0
	ret

DELAY_01:
	; Generated by delay loop calculator
	; at http://www.bretmulvey.com/avrdelay.html
	;
	; DELAY_CONTROL 40 000 cycles
	; 5ms at 8.0 MHz

	    ldi  r18, 52
	    ldi  r19, 242
	L1: dec  r19
	    brne L1
	    dec  r18
	    brne L1
	    nop
	ret

DELAY_02:
; Generated by delay loop calculator
; at http://www.bretmulvey.com/avrdelay.html
;
; Delay 160 000 cycles
; 20ms at 8.0 MHz

	    ldi  r18, 208
	    ldi  r19, 202
	L2: dec  r19
	    brne L2
	    dec  r18
	    brne L2
	    nop
		ret

COPY_SOALTABLE_TO_MEMORY:
	ldi ZL, low(2*SoalTable)
	ldi ZH, high(2*SoalTable)
	ldi YL, low(qATable)
	ldi YH, high(qATable)
	FOR_MOVE_DATA:
		LOAD_DATA_TO_MEM:
			lpm temp, Z+ ;Load byte from program memory
			tst temp
			breq LOAD_DATA_TO_MEM
		st Y+, temp
		cpi temp, 'a'
		brne FOR_MOVE_DATA ; If loop_count != x, keep the loop
	ret

START_GAME:
	ldi temp, 99
	mov timer, temp
	ldi YL,low(qATable) ; Load low part of byte address into YL


	
	START_SOAL:
		rcall SET_CURSOR_OFF
		ldi iODat, $D8;
		rcall CHANGE_LCD_POINTER
		rcall CLEAR_TEXT_ONE_ROW
		ldi iODat, $D8;
		rcall CHANGE_LCD_POINTER
		rcall SET_CURSOR_ON
			LOADSOAL:
				ldi counter, 0 
				ld iODat, Y+ ; Load byte from program memory into iODat
				cpi iODat, 'V'
				breq READKEY
				cpi iODat, 'a'
				breq EXIT	
				rcall WRITE_TEXT_NO_COUNTER
				rjmp LOADSOAL

SET_CURSOR_ON:
	cbi PORTA,1 ; CLR RS
	ldi iODat,$0E ; MOV DATA,0x0E --> disp ON, cursor ON, blink OFF
	out PORTB,iODat
	sbi PORTA,0 ; SETB EN
	cbi PORTA,0 ; CLR EN
	ret	

SET_CURSOR_OFF:
	cbi PORTA,1 ; CLR RS
	ldi iODat,$0C ; MOV DATA,0x0C --> disp ON, cursor OFF, blink OFF
	out PORTB,iODat
	sbi PORTA,0 ; SETB EN
	cbi PORTA,0 ; CLR EN
	ret


CHANGE_LCD_POINTER:
	cbi PORTA,1 ; CLR RS
	out PORTB,iODat
	sbi PORTA,0 ; SETB EN
	cbi PORTA,0 ; CLR EN
	rcall DELAY_01

CHANGE_LCD_POINTER2:
	cbi PORTA,6 ; CLR RS
	out PORTB,iODat2
	sbi PORTA,5 ; SETB EN
	cbi PORTA,5 ; CLR EN
	rcall DELAY_00	

	; sbi PORTA,1 ; CLR RS
	; ldi iODat,$31 ; MOV DATA,0x01
	; out PORTB,iODat
	; sbi PORTA,0 ; SETB EN
	; cbi PORTA,0 ; CLR EN
	; rcall DELAY_01
	ret

EXIT:
	rjmp EXIT


INIT_KEYPAD:
	; INIT KEYPAD
    ldi iODat,0b01110000  ; data direction register column lines output
    out DDRC, iODat       ; set direction register
    ldi iODat,0b00001111  ; Pull-Up-Resistors to lower four port pins
    out PORTC,iODat       ; to output port
	ret

INIT_LED:
	; INIT LED
	ser iODat ; load $FF to iODat
	out DDRE, iODat ; Set PORTC as output
    ldi iODat, 0b11111110
    out PORTE, iODat
    ldi iODat, 0b00000000
    out PORTE, iODat	
	ret


; Identify the key pressed
READKEY:
	tst listenReset
	brne INIT_LCD_MAIN_REL_TO_RESET
	ldi ZH,HIGH(2*KeypadTable) ; Z is pointer to key code table
	ldi ZL,LOW(2*KeypadTable)
	; read column 1
	ldi iODat,0b00111111 ; PB6 = 0
	out PORTC,iODat
	in iODat,PINC ; read input line
	ori iODat,0b11110000 ; mask upper bits
	cpi iODat,0b11111111 ; a key in this column pressed?
	brne KEY_ROW_FOUND ; key found
	adiw ZL,4 ; column not found, point Z one row down
	; read column 2
	ldi iODat,0b01011111 ; PB5 = 0
	out PORTC,iODat
	in iODat,PINC ; read again input line
	ori iODat,0b11110000 ; mask upper bits
	cpi iODat,0b11111111 ; a key in this column?
	brne KEY_ROW_FOUND 	; column found
	adiw ZL,4 ; column not found, another four keys down
	; read column 3
	ldi iODat,0b01101111 ; PB4 = 0
	out PORTC,iODat
	in iODat,PINC ; read last line
	ori iODat,0b11110000 ; mask upper bits
	cpi iODat,0b11111111 ; a key in this column?
	breq NO_KEY ; unexpected: no key in this column pressed

KEY_ROW_FOUND: ; column identified, now identify row
	lsr iODat ; shift a logic 0 in left, bit 0 to carry
	brcc KEY_FOUND ; a zero rolled out, key is found
	adiw ZL,1 ; point to next key code of that column
	rjmp KEY_ROW_FOUND ; repeat shift

KEY_FOUND: ; pressed key is found 
	lpm ; read key code to R0
	rjmp KEY_PROC ; countinue key processing

KEY_PROC:
	mov iODat, r0
	cpi counter, 0 ;tens
	breq COUNTING_TENS
	cpi counter, 1
	breq VALIDATE
    rjmp READKEY
	
NO_KEY:
    ; ldi iODat, 0b00001111
    ; out PORTE, iODat
	; rcall DELAY_02
	rjmp READKEY ; no key pressed	

INIT_LCD_MAIN_REL_TO_RESET:
	ldi counter,0
	ldi iODat, 0
	ldi counterLEDPoint, 0
	ldi value, 0
	mov score, value
	ldi number, 0
	mov numberToCompare, number
	mov timer, value
	push temp
	ldi temp, 1
	mov listenStart, temp
	mov listenReset, value
	ldi temp, 0
	rjmp WAIT_MULAI		

COUNTING_TENS:
	ldi temp, 10
	mul iODat, temp
	mov value, r0
	rcall WRITE_KEYPAD_TO_LCD
	; ldi temp,0xFF
	; out PORTE,temp ; Update LEDS
	inc counter
	rcall DELAY_01
	rjmp READKEY

VALIDATE:
	; ldi temp,0xF8	
	; out PORTE,temp ; Update LEDS
	; rcall DELAY_02 ; rjmp EXIT
	add value, iODat
	rcall WRITE_KEYPAD_TO_LCD
	ld temp, Y+ ; Load byte from program memory into iODat
	cp temp, value
	breq EVAL_TRUE

EVAL_WRONG:
	dec counterLEDPoint
	cpi counterLEDPoint,0
	breq LED_ON0
	cpi counterLEDPoint, 1
	breq LED_ON1
	cpi counterLEDPoint, 2
	breq LED_ON2
	cpi counterLEDPoint, 3
	breq LED_ON3
	cpi counterLEDPoint, 4
	breq LED_ON4
	cpi counterLEDPoint, 5
	breq LED_ON5	

EVAL_TRUE:
	inc counterLEDPoint
	cpi counterLEDPoint,0
	breq LED_ON0
	cpi counterLEDPoint, 1
	breq LED_ON1
	cpi counterLEDPoint, 2
	breq LED_ON2
	cpi counterLEDPoint, 3
	breq LED_ON3
	cpi counterLEDPoint, 4
	breq LED_ON4
	cpi counterLEDPoint, 5
	breq LED_ON5

LED_ON0:
	ldi iODat,0x00
	out PORTE,iODat ; Update LEDS
	rcall DELAY_01
	rjmp START_SOAL

LED_ON1:
	ldi iODat,0x80
	out PORTE,iODat ; Update LEDS
	rcall DELAY_01
	rjmp START_SOAL

LED_ON2:
	ldi iODat,0xC0
	out PORTE,iODat ; Update LEDS
	rcall DELAY_01
	rjmp START_SOAL

LED_ON3:
	ldi iODat,0xE0
	out PORTE,iODat ; Update LEDS
	rcall DELAY_01
	rjmp START_SOAL

LED_ON4:
	ldi iODat,0xF0
	out PORTE,iODat ; Update LEDS
	rcall DELAY_01
	rjmp START_SOAL

LED_ON5:
	ldi iODat,0xF8	
	out PORTE,iODat ; Update LEDS
	rcall DELAY_01
	inc score
	mov numberToCompare, score
	ldi iODat, $CE;
	rcall CHANGE_LCD_POINTER
	rcall WRITE_DIGITS
	ldi counterLEDPoint, 0
	rjmp LED_ON0


INPUT_TEXT:
	ldi ZH,high(2*Message) ; Load high part of byte address into ZH
	ldi ZL,low(2*Message) ; Load low part of byte address into ZL
	ret


INIT_LCD_MAIN:
	rcall INIT_LCD

	ser temp
	out DDRA,temp ; Set port A as output
	out DDRB,temp ; Set port B as output

	rcall INPUT_TEXT
	


LOADBYTE:
	lpm ; Load byte from program memory into r0

	tst r0 ; Check if we've reached the end of the message
	breq END_LCD ; If so, quit

	mov iODat, r0 ; Put the character onto Port B
	rcall WRITE_TEXT
	cpi counter, 9
	breq WRITE_SEC
	adiw ZL,1 ; Increase Z registers
	rjmp LOADBYTE

LOADBYTE1:
	lpm ; Load byte from program memory into r0
	tst r0 ; Check if we've reached the end of the message
	breq END_LCD ; If so, quit
	mov iODat, r0 ; Put the character onto Port B
	cpi iODat, ' '
	breq LOADBYTE_TO_LCD_2
	rcall WRITE_TEXT
	cpi counter, 9
	breq WRITE_SEC
	adiw ZL,1 ; Increase Z registers
	rjmp LOADBYTE1
		LOADBYTE_TO_LCD_2:
			adiw ZL,1 ; Increase Z registers
			lpm ; Load byte from program memory into r0
			tst r0 ; Check if we've reached the end of the message
			breq END_LCD ; If so, quit
			mov iODat2, r0 ; Put the character onto Port B
			rcall WRITE_TEXT_LCD2
			rjmp LOADBYTE_TO_LCD_2



END_LCD:
	;ldi counter, 0
	;rcall INIT_LCD_MAIN1
	ret

RESET:
	in temp, SREG
	push temp

	ldi temp, 1
	mov listenReset, temp
	mov listenStart, temp

	pop temp
	out SREG, temp
	reti

WRITE_SEC:
	cbi PORTA,1 ; CLR RS
	ldi iODat,$C0 ; MOV DATA,0x01
	out PORTB,iODat
	sbi PORTA,0 ; SETB EN
	cbi PORTA,0 ; CLR EN
	rcall DELAY_01
	adiw ZL,1 ; Increase Z registers
	rjmp LOADBYTE
	ret	

INIT_LCD:
	cbi PORTA,1 ; CLR RS
	cbi PORTA,6 ; CLR RS
	ldi iODat,0x38 ; MOV DATA,0x38 --> 8bit, 2line, 5x7
	out PORTB,iODat
	sbi PORTA,0 ; SETB EN
	cbi PORTA,0 ; CLR EN
	sbi PORTA,5 ; SETB EN
	cbi PORTA,5 ; CLR EN
	rcall DELAY_01
	cbi PORTA,1 ; CLR RS
	cbi PORTA,6 ; CLR RS
	ldi iODat,$0E ; MOV DATA,0x0E --> disp ON, cursor ON, blink OFF
	out PORTB,iODat
	sbi PORTA,0 ; SETB EN
	cbi PORTA,0 ; CLR EN
	sbi PORTA,5 ; SETB EN
	cbi PORTA,5 ; CLR EN
	rcall DELAY_01
	rcall CLEAR_LCD ; CLEAR LCD
	rcall CLEAR_LCD2
	cbi PORTA,1 ; CLR RS
	cbi PORTA,6 ; CLR RS
	ldi iODat,$06 ; MOV DATA,0x06 --> increase cursor, display sroll OFF
	out PORTB,iODat
	sbi PORTA,0 ; SETB EN
	cbi PORTA,0 ; CLR EN
	sbi PORTA,5 ; SETB EN
	cbi PORTA,5 ; CLR EN
	rcall DELAY_01
	ret

CLEAR_LCD:
	cbi PORTA,1 ; CLR RS
	ldi iODat,$01 ; MOV DATA,0x01
	out PORTB,iODat
	sbi PORTA,0 ; SETB EN
	cbi PORTA,0 ; CLR EN
	rcall DELAY_01
	ret

CLEAR_LCD2:
	cbi PORTA,6 ; CLR RS
	ldi iODat,$01 ; MOV DATA,0x01
	out PORTB,iODat
	sbi PORTA,5 ; SETB EN
	cbi PORTA,5 ; CLR EN
	rcall DELAY_01
	ret	

CLEAR_TEXT_ONE_ROW:
	ldi counter, 10
	FOR_CLEAR_TEXT:
		sbi PORTA,1 ; Set RS
		ldi iODat,0x20 ; write 00 to lcd
		out PORTB,iODat
		sbi PORTA,0 ; SETB EN
		cbi PORTA,0 ; CLR EN
		dec counter
		tst counter
		brne FOR_CLEAR_TEXT
	ret

WRITE_TEXT:
	sbi PORTA,1 ; SETB RS
	out PORTB, iODat
	sbi PORTA,0 ; SETB EN
	cbi PORTA,0 ; CLR EN
	rcall DELAY_00
	inc counter
	ret

WRITE_TEXT_LCD2:
	sbi PORTA,6 ; SETB RS
	out PORTB,iODat2
	sbi PORTA,5 ; SETB EN
	cbi PORTA,5 ; CLR EN	
	rcall DELAY_00
	ret	

WRITE_TEXT_NO_COUNTER:
	sbi PORTA,1 ; SETB RS
	out PORTB, iODat
	sbi PORTA,0 ; SETB EN
	cbi PORTA,0 ; CLR EN
	rcall DELAY_00
	ret	

WRITE_KEYPAD_TO_LCD:
	subi iODat, 0b11010000
	sbi PORTA,1 ; SETB RS
	out PORTB, iODat
	sbi PORTA,0 ; SETB EN
	cbi PORTA,0 ; CLR EN
	rcall DELAY_01
	ret	

;Write digit to LCD

WRITE_DIGITS:
	; ldi number,100
	; cp numberToCompare,number		; 0XX
	; brlo PROCESS_0XX
	; ldi number,200			; 1XX
	; cp numberToCompare,number
	; brlo PROCESS_1XX
	; sub numberToCompare,number	; 2XX
	; ldi iODat,0x32
	; rcall WRITE_TEXT_NO_COUNTER
	; rjmp SECOND_NUMBER
	; PROCESS_0XX:
	; 	ldi iODat,0x30
	; 	rcall WRITE_TEXT_NO_COUNTER
	; 	rjmp SECOND_NUMBER	
	; PROCESS_1XX:
	; 	ldi iODat,0x31
	; 	rcall WRITE_TEXT_NO_COUNTER
	; 	subi number,100
	; 	sub numberToCompare,number
	rjmp SECOND_NUMBER	

	SECOND_NUMBER:
		ldi number,10
		cp numberToCompare,number	;0X
		brlo PROCESS_0X
		ldi number,20		;1X
		cp numberToCompare,number
		brlo PROCESS_1X
		ldi number,30		;2X
		cp numberToCompare,number
		brlo PROCESS_2X
		ldi number,40		;3X
		cp numberToCompare,number
		brlo PROCESS_3X
		ldi number,50		;4X
		cp numberToCompare,number
		brlo PROCESS_4X
		ldi number,60		;5X
		cp numberToCompare,number
		brlo PROCESS_5X
		ldi number,70		;6X
		cp numberToCompare,number
		brlo PROCESS_6X
		ldi number,80		;7X
		cp numberToCompare,number
		brlo PROCESS_7X
		ldi number,90		;8X
		cp numberToCompare,number
		brlo PROCESS_8X
		sub numberToCompare,number ;9X
		ldi iODat, 0x39
		rcall WRITE_TEXT_NO_COUNTER
		rjmp THIRD_NUMBER
	PROCESS_0X:
		ldi iODat,0x30
		rcall WRITE_TEXT_NO_COUNTER
		rjmp THIRD_NUMBER
	PROCESS_1X:
		ldi iODat,0x31
		rcall WRITE_TEXT_NO_COUNTER
		subi number,10
		sub numberToCompare,number
		rjmp THIRD_NUMBER
	PROCESS_2X:
		ldi iODat,0x32
		rcall WRITE_TEXT_NO_COUNTER
		subi number,10
		sub numberToCompare,number
		rjmp THIRD_NUMBER
	PROCESS_3X:
		ldi iODat,0x33
		rcall WRITE_TEXT_NO_COUNTER
		subi number,10
		sub numberToCompare,number
		rjmp THIRD_NUMBER
	PROCESS_4X:
		ldi iODat,0x34
		rcall WRITE_TEXT_NO_COUNTER
		subi number,10
		sub numberToCompare,number
		rjmp THIRD_NUMBER
	PROCESS_5X:
		ldi iODat,0x35
		rcall WRITE_TEXT_NO_COUNTER
		subi number,10
		sub numberToCompare,number
		rjmp THIRD_NUMBER
	PROCESS_6X:
		ldi iODat,0x36
		rcall WRITE_TEXT_NO_COUNTER
		subi number,10
		sub numberToCompare,number
		rjmp THIRD_NUMBER
	PROCESS_7X:
		ldi iODat,0x37
		rcall WRITE_TEXT_NO_COUNTER
		subi number,10
		sub numberToCompare,number
		rjmp THIRD_NUMBER
	PROCESS_8X:
		ldi iODat,0x38
		rcall WRITE_TEXT_NO_COUNTER
		subi number,10
		sub numberToCompare,number
		rjmp THIRD_NUMBER

	THIRD_NUMBER:
		tst numberToCompare		;0
		breq PROCESS_0
		ldi number,1
		cp numberToCompare,number	;1
		breq PROCESS_1
		ldi number,2
		cp numberToCompare,number	;2
		breq PROCESS_2
		ldi number,3
		cp numberToCompare,number	;3
		breq PROCESS_3
		ldi number,4
		cp numberToCompare,number	;4
		breq PROCESS_4
		ldi number,5
		cp numberToCompare,number	;5
		breq PROCESS_5
		ldi number,6
		cp numberToCompare,number	;6
		breq PROCESS_6
		ldi number,7
		cp numberToCompare,number	;7
		breq PROCESS_7
		ldi number,8
		cp numberToCompare,number	;8
		breq PROCESS_8
		ldi iODat,0x39	;9
		rcall WRITE_TEXT_NO_COUNTER
		ret
	PROCESS_0:
		ldi iODat,0x30
		rcall WRITE_TEXT_NO_COUNTER
		ret
	PROCESS_1:
		ldi iODat,0x31
		rcall WRITE_TEXT_NO_COUNTER
		ret
	PROCESS_2:
		ldi iODat,0x32
		rcall WRITE_TEXT_NO_COUNTER
		ret
	PROCESS_3:
		ldi iODat,0x33
		rcall WRITE_TEXT_NO_COUNTER
		ret
	PROCESS_4:
		ldi iODat,0x34
		rcall WRITE_TEXT_NO_COUNTER
		ret
	PROCESS_5:
		ldi iODat,0x35
		rcall WRITE_TEXT_NO_COUNTER
		ret
	PROCESS_6:
		ldi iODat,0x36
		rcall WRITE_TEXT_NO_COUNTER
		ret
	PROCESS_7:
		ldi iODat,0x37	
		rcall WRITE_TEXT_NO_COUNTER
		ret
	PROCESS_8:
		ldi iODat,0x38
		rcall WRITE_TEXT_NO_COUNTER
		ret



WRITE_TIME_LEFT:
	ldi temp, 1
	mov writeTo2, temp

	mov numberToCompare,timer
	ldi iODat2, $96;
	rcall CHANGE_LCD_POINTER2
	
	; rcall WRITE_DIGITS
	ldi temp, 0
	mov writeTo2, temp
	ret


INIT_INTERRUPT:
	ldi iODat,0b0001010
	out MCUCR,iODat
	ldi iODat,0b11000000
	out GICR,iODat
	sei
	ret

INIT_TIMER:
	ldi iODat, (1<<CS02)|(1<<CS00)	; 
	out TCCR0,iODat			
	ldi iODat,1<<TOV0
	out TIFR,iODat		; Interrupt if overflow occurs in T/C0
	ldi iODat,1<<TOIE0
	out TIMSK,iODat		; Enable Timer/Counter0 Overflow int
	ser iODat
	out DDRB,iODat		; Set port B as output
	ret

DISABLE_INTERRUPT:
	; disable ext interrupt
	ldi temp,0b11000000
	out GICR,temp ; Clear INT0 and INT1
	ldi temp,0b00000000
	out GICR,temp ; Disable INT0 and INT1

	; disable timer
	ldi temp,0b11000000
	out GIFR, temp

	in temp,TIFR
	andi temp, 0b11111101
	out TIFR, temp
	in temp, TIMSK
	andi temp, 0b11111101
	out TIMSK, temp
	in temp, TCCR0
	andi temp, 0b11111000
	cli
	ret	
	

MULAI:
	in temp, SREG
	push temp

	inc counter
	mov listenStart, counter
	ldi counter, 0

	pop temp
	out SREG, temp
	reti

ISR_TOV0:
	push temp
	in temp,SREG
	push temp
	push iODat

	rcall WRITE_TIME_LEFT
	cp timer, r0
	brne DEC_TIMER
	; rcall END_GAME
	DEC_TIMER:
	dec timer

	pop temp
	out SREG,temp
	pop temp
	pop iODat
	reti

INPUT_TEXT1:
	ldi ZH,high(2*Timescore) ; Load high part of byte address into ZH
	ldi ZL,low(2*Timescore) ; Load low part of byte address into ZL

	rjmp LOADBYTE1

INIT_LCD_MAIN1:
	ldi counter, 0
	rcall INIT_LCD

	ser temp
	out DDRA,temp ; Set port A as output
	out DDRB,temp ; Set port B as output

	rcall INPUT_TEXT1

END:
	ret
	

;====================================================================
; DATA
;====================================================================



Message:
.db "WELCOME! DARE YOUR SELF",0

Timescore:
.db "SCORE:00 TIMER:99",0

;Keypad table for code conversion
KeypadTable:
.db 0x23,7,4,1 ; First column, keys *, 7, 4 dan 1
.db 0,8,5,2 ; second column, keys 0, 8, 5 dan 2
.db 0x0B,9,6,3 ; third column, keys #, 9, 6 dan 3        

SoalTable:
.db "12x1 = ", 'V', 12
.db "12x2 = ", 'V', 24
.db "12x3 = ", 'V', 36
.db "12x4 = ", 'V', 48
.db "12x5 = ", 'V', 60
.db "12x6 = ", 'V', 72
.db "12x7 = ", 'V', 84 
.db "11X3 = ", 'V', 33
.db "11X1 = ", 'V', 11 
.db "11X2 = ", 'V', 22, "a"

